/*

*/

import renderer.scene.*;
import renderer.pipeline.*;
import renderer.framebuffer.*;

/**
   Draw a simple scene with a single model
   that is a square within a square.
*/
public class Example1
{
   public static void main(String[] args)
   {
      final Scene scene = new Scene();

      final Model decoratedSquare = new Model("Decorated Square");
      decoratedSquare.addVertex(new Vertex(-1, -1, -3),
                                new Vertex(-1,  0, -3),
                                new Vertex(-1,  1, -3),
                                new Vertex( 0,  1, -3),
                                new Vertex( 1,  1, -3),
                                new Vertex( 1,  0, -3),
                                new Vertex( 1, -1, -3),
                                new Vertex( 0, -1, -3));
      decoratedSquare.addLineSegment(new LineSegment(0, 2),
                                     new LineSegment(2, 4),
                                     new LineSegment(4, 6),
                                     new LineSegment(6, 0),
                                     new LineSegment(1, 3),
                                     new LineSegment(3, 5),
                                     new LineSegment(5, 7),
                                     new LineSegment(7, 1));
      scene.addModel(decoratedSquare);

      final FrameBuffer fb = new FrameBuffer(800, 800);
      Pipeline.render(scene, fb);
      fb.dumpFB2File("example1.ppm");
   }
}
